<template>
    <v-container class="connection">
        <v-row align="center" justify="center" class="pa-5">
            <v-flex>
                <h1 class="heading text-center">Connection</h1>
                <hr class="ma-4"/>
                <v-form ref="form" v-model="valid" lazy-validation>
                    <v-text-field outlined
                                  v-model="email"
                                  label="Mail"
                                  type="mail"
                                  :rules="emailRules"
                                  :counter="255"
                                  required
                    ></v-text-field>

                    <v-text-field outlined
                                  v-model="password"
                                  :append-icon="show ? 'mdi-eye' : 'mdi-eye-off'"
                                  :type="show ? 'text' : 'password'"
                                  label="Password"
                                  @click:append="show = !show"
                                  :rules="passwordRules"
                                  :counter="255"
                                  required
                                  clearable
                    ></v-text-field>

                    <div class="text-center">
                        <v-btn :disabled="!valid" color="success" class="mr-4" @click="validate">
                            Connection
                        </v-btn>

                        <v-btn color="error" class="mr-4" @click="reset">
                            Reset Form
                        </v-btn>

                        <v-btn color="warning" @click="resetValidation">
                            Reset Validation
                        </v-btn>
                    </div>
                </v-form>
            </v-flex>
        </v-row>
    </v-container>
</template>

<script>
    import sha256 from 'crypto-js/sha256';

    import Services from "../services";
    import {SET_PLAYER} from "../store/mutations.type";

    export default {
        name: "Connection",
        data: function () {
            return {
                valid: false,
                email: null,
                emailRules: [
                    v => !!v || 'E-mail is required',
                    v => /.+@.+\..+/.test(v) || 'E-mail must be valid',
                ],
                password: null,
                passwordRules: [
                    v => !!v || 'Password is required',
                    v => (v && v.length < 255) || 'Password must be less than 255 characters',
                ],
                show: false
            }
        },
        methods: {
            validate: function () {
                if (this.email != null && this.password != null) {
                    Services.connectPlayer(this.email, sha256(this.password).toString()).then((data) => {
                        if (data.result && data.id)
                            Services.getPlayer(data.id).then(data => {
                                this.$store.commit(SET_PLAYER, data);
                                this.$router.push("/");
                            })
                        else
                            this.$notify({
                                type: "error",
                                title: "Connection failed",
                                text: "Please check your informations or sign up"
                            })
                    }).catch((e) => {
                        this.$notify({
                            type: "error",
                            title: "Connection failed",
                            text: e.toString()
                        })
                    });
                } else
                    this.valid = false;
            },
            reset: function () {
                this.$refs.form.reset();
                this.valid = false;
            },
            resetValidation: function () {
                this.$refs.form.resetValidation();
                this.valid = false;
            }
        }
    }
</script>

<style scoped>
    .connection {
        background-color: #222222;
        border-radius: 1em;
        max-width: 75%;
    }
</style>